//
// anyRemote
// a bluetooth remote for your PC.
//
// Copyright (C) 2006-2011 Mikhail Fedotov <anyremote@mail.ru>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//

#ifndef _CONF_H_
#define _CONF_H_

#include "parse.h"

char* getFirstAlarm     (char **cmds);
char* getNextAlarm      (char **cmds);
char* getAT_CMER     	(int what);
char* getCfgDir         (void);
char* getCharset        (void);
char* getDevice         (void);
char* getMode           (void);
char* getToMainMenu     (void);
char* getServiceName    (void);
int   autoConnect       (void);
int   getAutoRepeat     (void);
int   getBaudrate       (void);
int   getDebug          (void);
int   getFrontEnd       (void);
int   getLog            (void);
int   getModel          (void);
int   getRetrySecs  	(void);
int   getUseScreen      (void);
int   getHttp           (void);
int   getIViewer        (void);
int   usePassword       (void);
void  addAlarm		(char *file, char *macro);
void  freeCfg           (void);
void  freeCfgEx         (mode* pmodes, type_alarm* palarms);
void  freeCmds          (cmdItem* item);
void  printConf         (void);
void  printKeys		(void);
void  setModel          (char *m);

void setRepeatNow       (type_key *k);
type_key* repeatNow     ();

type_key* findItem	(char *key, int *flag, cmdParams *param);
cmdItem* getCommand	(type_key* item);

#endif
